# Advent of Code 12/3/2022, puzzle 1 -- Sums of rucksack priorities

infile = "3_1_input.txt"


data = open(infile)

priorities = [] # the list of priorities we'll build

for sack in data:
	# calculate a halfway point in the string and split it into equal-sized compartments
	halfway = int(len(sack)/2)
	first = sack[:halfway]
	second = sack[halfway:]

	# stock a hash with k/v pairs for each letter in the first string
	manifest = {}
	for i in range(len(first)):
		manifest[first[i]] = 1

	# try each of the letters in the second bag to see if it is already in the hash
	for i in range(len(second)):
		if second[i] in manifest:
			priorities.append(second[i])
			break

# and then convert those to numeric values and sum them up
total = 0
for p in priorities:
	# get ASCII val for each letter and subtract offsets so a=1, b=2, ... z=26, A=27 ...
	pval = ord(p) - 38
	if p.islower():
		pval -= 58

	total += pval

print("Total: ", total)
