# Advent of Code 12/7/2022, puzzle 2 -- find the smallest large-enough directory

# lightly modifying 7_1

import sys

infile = "7_1_input.txt"

data = open(infile)

filesys = {"filez": []} # we'll set up a fake file system in an associative array
currdir = [] # position in the filesystem, as a list of subdirs in order, empty is root

# produce a reference to an area in the filesys structure referred to by a given list of subdirs
def getdir(subs):
	tempdir = filesys
	for s in subs:
		if s in tempdir:
			tempdir = tempdir[s]
		else:
			print("invalid dir situation, man: ", subs)
	return tempdir

# handle navigation within the filesystem
def cd(cdarg):
	global currdir # gonna just use that main one instead of passing things around
	if cdarg == "/":
		currdir = []
	elif cdarg == "..":
		currdir.pop()
	else:
		if not cdarg in getdir(currdir):
			getdir(currdir)[cdarg] = {"filez": []}	
		currdir.append(cdarg)
		#else:
			# this is bad, why are we trying to enter a non-existent subdir?
		#	print("invalid subdirectory ", cdarg, " in ", currdir)
#	print("Changing to directory: ", currdir)
	return 

# handle listing of files and subdirectories in current directory
def ls():
	global currdir
	while True:
		lastpos = data.tell() # store the current file position...
		cmd = data.readline().strip() # read in a new line...
		if cmd == "":
			# end of file, let's bail
			return
		tokens = cmd.split(" ")
		if tokens[0] == "$":
			data.seek(lastpos) # and if we're at a new command then step back a line in the file and bail
			return
		else:
			# otherwise, we've got some work to do: 
			# 1. add each plain file + its size as a tuple to a list in this subdir
			# 2. add each directory as a key in the current position in filesys
			if tokens[0] == "dir":
				# add the new subdir key pointing to an empty list, ONLY if it's not already there
				tempdir = getdir(currdir)
				if not tokens[1] in tempdir:
					tempdir[tokens[1]] = {"filez": []}
			else:
				fsize = tokens[0]
				fname = tokens[1] 
				getdir(currdir)["filez"].append([fsize, fname])
	return

while True: 
	cmd = data.readline().strip()
#	print("New command: ", cmd)
	# ditch at the end of the file
	if(cmd == ""):
		break

	# still here? let's tokenize the string across spaces	
	tokens = cmd.split(" ")

	# the plan: call a function for every command, and make it the responsibility of that function
	#  to process non-command lines before returning the next command.
	if tokens[0] != "$":
		print("uh oh, got a non-command when expecting a command: ", cmd)
		sys.exit()

	if tokens[1] == "cd":
		# handle directory navigation
		cd(tokens[2])
	elif tokens[1] == "ls":
		ls()
		# handle file listing
	else:
		print("unknown command: ", cmd)
		sys.exit()

# calc the totals for each directory
def totaldir(dir):
	total = 0
	for k in dir:
		if k == "filez":
			total = 0
			for f in dir[k]:
				total += int(f[0])
			#dir["filetotal"] = total
		else:
			totaldir(dir[k])
			total += dir[k]["filetotal"]
	dir["filetotal"] = total

totaldir(filesys)

# and then look for the smallest directory greater than the needed file space target
leastbig = 70000000
target = 30000000 - (70000000 - filesys["filetotal"]) 

def searchdir(dir):
	global leastbig
	for k in dir:
		if k == "filetotal":
			if dir[k] > target and dir[k] < leastbig:
				leastbig = dir[k]
		elif k == "filez":
			continue
		else: 
			searchdir(dir[k])

searchdir(filesys)
print("least big: ", leastbig)