# Advent of Code 12/8/2022, puzzle 2 -- rating treehouse site visibility


import sys
import copy

infile = "8_1_input.txt"
#infile = "testinput_8.txt"

data = open(infile)

forest = list(data)
trees = []
for i in range(len(forest)):
	# this list comprehension stuff seems nice...
	newline = [int(x) for x in forest[i].strip()]
	trees.append(newline)

width = len(trees[0])
height = len(trees)

# this is a lazy way to get a new nested array with the right dimensions; we don't actually
#  care about the values though so this is slightly nasty thinking
field = copy.deepcopy(trees)

topscore = 0
for i in range(height):
	for j in range(width):
		# for each tree, we'll march left, right, up, and down until we reach an edge or another
		#  tree as tall or taller than this candidate.
		
		r = 1
		l = 1
		b = 1
		t = 1
		
		# to the right
		distance = 1
		for k in range(j+1, width-1, 1):
			if trees[i][k] >= trees[i][j]:
				break
			distance += 1
		r = distance

		# to the left
		distance = 1
		for k in range(j-1, 0, -1):
			if trees[i][k] >= trees[i][j]:
				break
			distance += 1
		l = distance

		# to the bottom
		#  with just "height" as the middle value of the range operator in this block I was getting
		#  an off-by-one error for a high-scorer that reached all the way out to the bottom edge;
		#  I am not seeing why that is, but modifying the range satisfied the test input so, huh.
		#  Maybe a bad assumption on my part about the truth outcome of that if and the resulting break
		#  for the range boundary question?  Dunno why that would have ended up instead as a fuckin'
		#  out of bounds index but whatever
		distance = 1
		for m in range(i+1, height-1, 1):
			if trees[m][j] >= trees[i][j]:
				break
			distance += 1
		b = distance

		# and to the top
		distance = 1
		for m in range(i-1, 0, -1):
			if trees[m][j] >= trees[i][j]:
				break
			distance += 1
		t = distance

		score = r * l * b * t
		if score > topscore:
			topscore = score
			print("New top score at ", i, ",", j, ": ", topscore, ": ",r,l,b,t)
		#print("Score: ", score)

print("Top tree score: ", topscore)

