# Advent of Code 12/9/2022, puzzle 1 -- counting tail positions

infile = "9_1_input.txt"

data = open(infile)

# parse the input data into move info
lines = list(data)
moves = []
for l in lines:
	tokens = l.strip().split()
	moves.append( {'dir': tokens[0], 'length': int(tokens[1]) } )

#print(moves)

# this rope is gonna wander around a field of unknown size and unknown bounds.  I've 
#  got a couple ways I could track which tiles its tail has visited: pre-process the move 
#  data to find field bounds and then define a 2D array to mark up, or just track the 
#  moves positions directly as x,y pairs and record a list of tail positions similarly
#  as pairs in a list, no array required.

# also betting for the record before seeing problem two that it's gonna make the rope
#  longer on me.

# the origin is as good an origin as any, I figure. There's no absolute position info available.
headpos = dict(x=0, y=0)
tailpos = dict(x=0, y=0)
# we'll add True values to an associative array for each visited coord, including the start.
travelogue = {(tailpos['x'],tailpos['y']): True}

# translate our move direction letters into unit offsets on the 2D plane
delta = {'R': {'x':1, 'y':0}, 'L': {'x':-1, 'y':0}, 'U': {'x':0, 'y':1}, 'D': {'x':0, 'y':-1} }

# update position of tailpos relative to headpos: expects to be called after each headpos step
def chase():
	dx = headpos['x'] - tailpos['x']
	dy = headpos['y'] - tailpos['y']
	if dx > 1:
		tailpos['x'] = headpos['x'] - 1
		tailpos['y'] = headpos['y']
	elif dx < -1:
		tailpos['x'] = headpos['x'] + 1
		tailpos['y'] = headpos['y']
	elif dy > 1:
		tailpos['x'] = headpos['x'] 
		tailpos['y'] = headpos['y'] - 1
	elif dy < -1:
		tailpos['x'] = headpos['x'] 
		tailpos['y'] = headpos['y'] + 1

	return


for m in moves:
	for i in range(m['length']):
		headpos['x'] += delta[m['dir']]['x']
		headpos['y'] += delta[m['dir']]['y']
		# call a function that rectifies tailpos compared to new headpos
		chase()
		# record new tailpos in list of visited tiles
		travelogue[ (tailpos['x'],tailpos['y']) ] = True





print(headpos)
print(tailpos)
print(list(travelogue))
print("Number of tail stops: ", len(travelogue))