# trying to better understand matplotlib figure and axis stuff

import numpy as np
import matplotlib.patches as mpatches
from matplotlib.collections import PatchCollection
import matplotlib.pyplot as plt

import random
import math
import copy
import os

from cortexlib import *

# draw a gradient of circuitously-hatched tiles with hatching density increasing toward the top right
def draw_circuitgradient(width,height,step,col="black"):
    patches = []
    squareg = getsquaregrid(width,height,step)

    for i in range(len(squareg)):
        for j in range(len(squareg[i])):
            lines = circuitpolyline(squareg[i][j],int((i+j)**1.1 + 2))
            for l in lines:
                patches.append(mpatches.Polygon(l,closed=False,fill=None,color=col))
    return patches

# draw a gradient of circuitously-hatched tiles with hatching density increasing toward the top right
def draw_circuitrand(width,height,step,col="black"):
    patches = []
    squareg = getsquaregrid(width,height,step)

    for i in range(len(squareg)):
        for j in range(len(squareg[i])):
            lines = circuitpolyline(squareg[i][j],int(random.random() * 20) + 2)
            for l in lines:
                patches.append(mpatches.Polygon(l,closed=False,fill=None,color=col))
    return patches




# OKAY NOW let's do a bunch of setup and drawing

# setting up figures and subplots in matplotlib, I really still don't know what the fuck I'm doing
# with most of this
fig = plt.figure(figsize=(9, 9), dpi=100, frameon=False)

w = 8
h = 8
s = 7

x_bounds = [-5 , w*s + 5] 
y_bounds = [-5, h*s + 5]

'''
#generate numd overlapping full-page axes
numd = 3 # number of drawings we're gonna stack up
axs = []
for i in range(numd):
    axs.append(fig.add_axes([0,0,1,1]))
'''

''
#generate a grid of distinct drawings
numx = 2 # columns
numy = 2 # rows
dx = 1/numx
dy = 1/numy
axs = []
for i in range(numx):
    for j in range(numy):
        axs.append(fig.add_axes([dx*i,dx*j,dx,dy]))
''

outfiles = []
# stock the axes and write out individual files
for i in range(len(axs)):
    patches = []
    patches += draw_circuitrand(w,h,s,[random.random(),random.random(),random.random(),1])

    axs[i].set_frame_on(False)
    axs[i].set_aspect('equal')
    axs[i].axis('off')
    axs[i].set_xlim(x_bounds)
    axs[i].set_ylim(y_bounds)

    collection = PatchCollection(patches, match_original=True)
    axs[i].add_collection(collection)

    filename = 'out' + str(i) + '.svg'
    outfiles.append(filename)
    plt.savefig(filename, bbox_inches = 'tight', pad_inches = 0)

    axs[i].clear()


# setup an shell invocation of vpype to produce output file
vstring = "vpype "
for i in range(len(outfiles)):
    vstring += 'read --single-layer --layer ' + str(i+1) + ' ' + outfiles[i] + ' '

vstring += 'write out.svg'

os.system(vstring)




