# doing some hatched grids

from cortexdraw import *

width = 15
height = 13
step = 10


fig, ax = plt.subplots(figsize=(11, 8.5), frameon=False)

patches = []
squareg = getsquaregrid(width,height,step)

for i in range(len(squareg)):
    for j in range(len(squareg[i])):
        lines = circuitpolyline(squareg[i][j],int((i+j)**1.1 + 2))
        a = 0

        for l in lines:
            patches.append(mpatches.Polygon(l,closed=False,fill=None,color="black"))


plt.grid(False)
plt.axis('off')
ax.set_aspect('equal')

x_bounds = [-5, width*step + 5]
y_bounds = [-5, height*step + 5]

ax.set_xlim(x_bounds)
ax.set_ylim(y_bounds)

collection = PatchCollection(patches, match_original=True)
ax.add_collection(collection)

outfile = "grid_hatch.svg"
plt.savefig(outfile, bbox_inches = 'tight', pad_inches = 0)
plt.show()

vpypeout([outfile])

