# hatchy hack

import numpy as np
import matplotlib.patches as mpatches
from matplotlib.collections import PatchCollection
import matplotlib.pyplot as plt

import random
import math
import copy


width = 100
height = 100

lines = []

# nicked from stack overflow
def find_intersection( p0, p1, p2, p3 ) :

    s10_x = p1[0] - p0[0]
    s10_y = p1[1] - p0[1]
    s32_x = p3[0] - p2[0]
    s32_y = p3[1] - p2[1]

    denom = s10_x * s32_y - s32_x * s10_y

    if denom == 0 : return None # collinear

    denom_is_positive = denom > 0

    s02_x = p0[0] - p2[0]
    s02_y = p0[1] - p2[1]

    s_numer = s10_x * s02_y - s10_y * s02_x

    if (s_numer < 0) == denom_is_positive : return None # no collision

    t_numer = s32_x * s02_y - s32_y * s02_x

    if (t_numer < 0) == denom_is_positive : return None # no collision

    if (s_numer > denom) == denom_is_positive or (t_numer > denom) == denom_is_positive : return None # no collision


    # collision detected
    t = t_numer / denom
    intersection_point = [ p0[0] + (t * s10_x), p0[1] + (t * s10_y) ]


    return intersection_point


def getlines():
    l = []
    height = 10
    step = random.random() * 2 + 0.25

    if(random.random() > 0.5):
#        for x in range(1,15,step):
        x = 0
        while x < 15:
            l.append([ [x,0], [x+(height*0.866),height] ])
#            step = random.random() * 2 + 0.25
            x += step
    else:
        y = 0
        while y < 11:
            l.append([ [y,y], [y+13,y] ])
 #           step = random.random() * 2 + 0.25
            y += step
    return l
    
def copyshift(lines,xshift,yshift):
    lout = []
    for l in lines:
        lnew = copy.deepcopy(l)
        lnew[0][0] += xshift
        lnew[0][1] += yshift
        lnew[1][0] += xshift
        lnew[1][1] += yshift
        lout.append(lnew)
    return lout

def slant(lines,slantmag=2):
    for l in lines:
        mag = 1/(len(l))
        for p in l:
            p[0] += (random.random() - 0.5) * slantmag * mag
    return lines

def twist(lines):
    for l in lines:
        l[1][0] = width - l[1][0]
    return lines

def feather(lines,feathermag=2):
    for l in lines:
        for p in l:
            p[1] += (random.random() - 0.5) * feathermag
    return lines

def divide(lines, iterations):
    newl = []
    for k in range(iterations):
        for i in range(len(lines)):
            newl.append( [lines[i][0]] )
            for j in range(len(lines[i])-1): 
                p1 = lines[i][j]
                p2 = lines[i][j+1]
                mid = [ (p1[0] + p2[0]) / 2,  ( p1[1] + p2[1]) / 2  ]
                newl[i].append(mid)
                newl[i].append(p2)
        
        lines = newl
        newl = []
    return lines


# take a set of unconnected lines and create new lines joining each gap
def joinlines(lines):
    knex = []
    for i in range(0,len(lines)-1):
        side = 0
        if(i%2): side = len(lines[i]) - 1
        endp = lines[i][side]
        startp = lines[i+1][side]
        knex.append([endp,startp])
    lines += knex
    return lines


fig, ax = plt.subplots(figsize=(11, 8.5))

patches = []

'''
pile = []

lines = getlines()

for i in range(3):
    for j in range(3):
        newl = copyshift(getlines(), i*14 + j*9 , j*10)
        newl = slant(newl,random.random() * 2)
        newl = feather(newl,random.random() * 2)
        newl = divide(newl,6)
        newl = slant(newl,random.random() * .5)
        newl = feather(newl,random.random() * .5)
        newl = joinlines(newl)
        
        pile.append(newl)


#lines = divide(lines,6)
#lines = slant(lines)
#lines = feather(lines)
#lines = twist(lines)

for chunk in pile:
    for p in chunk:
        patches.append(mpatches.Polygon(p, closed=False, fill=None))
'''


# gin up some random lines
lines = []
inters = []
for i in range(10):
    lines.append([ [random.random() * 50, random.random() * 50], [random.random() * 50, random.random() * 50]])
    patches.append(mpatches.Polygon(lines[i],closed=False, fill=None, color="black"))

# test them all for intersections
for i in range(len(lines)-1):
    for j in range(i+1, len(lines)):
        p1 = lines[i][0]
        p2 = lines[i][1]
        p3 = lines[j][0]
        p4 = lines[j][1]
        p = find_intersection(p1,p2,p3,p4)
        if(p != None): 
            patches.append(mpatches.Circle(p, radius= 0.5, fill=None, color="green"))
            inters.append(p)

for i in range(len(inters)-1):
    for j in range(i+1, len(inters)):
        patches.append(mpatches.Polygon([ inters[i],inters[j] ], closed=False, fill=None, color="red" ))

plt.grid(False)
plt.axis('off')
ax.set_aspect('equal')

x_bounds = [-5, 55]
y_bounds = [-5, 55]

ax.set_xlim(x_bounds)
ax.set_ylim(y_bounds)

collection = PatchCollection(patches, match_original=True)
ax.add_collection(collection)

plt.savefig('hatch.svg', bbox_inches = 'tight', pad_inches = 0)
plt.show()


